package com.rl2.example.config {
	import robotlegs.bender.extensions.contextView.ContextView;
	import robotlegs.bender.extensions.eventCommandMap.api.IEventCommandMap;
	import robotlegs.bender.extensions.matching.TypeMatcher;
	import robotlegs.bender.extensions.mediatorMap.api.IMediatorMap;
	import robotlegs.bender.framework.api.IConfig;
	import robotlegs.bender.framework.api.IInjector;

	import com.rl2.example.controller.SetupCommand;
	import com.rl2.example.event.ApplicationEvent;
	import com.rl2.example.view.BaseView;
	import com.rl2.example.view.InterfaceMediator;
	import com.rl2.example.view.InterfaceView;
	import com.rl2.example.view.MainMenuMediator;
	import com.rl2.example.view.MainMenuView;
	import com.rl2.example.view.SideMenuMediator;
	import com.rl2.example.view.SideMenuView;

	import flash.events.IEventDispatcher;

	/**
	 * @author Jonathan
	 */
	public class AppConfig implements IConfig {
		
		[Inject]
		public var injector:IInjector;
		
		[Inject]
		public var mediatorMap:IMediatorMap;
		
		[Inject]
		public var commandMap:IEventCommandMap;
		
		[Inject]
		public var eventDispatcher:IEventDispatcher;
		
		[Inject]
		public var contextView:ContextView;

		public function AppConfig() {
		}

		
		public function configure():void {
			mediatorMap.mapMatcher(new TypeMatcher().allOf(BaseView, InterfaceView)).toMediator(InterfaceMediator);
			mediatorMap.mapMatcher(new TypeMatcher().allOf(BaseView, MainMenuView)).toMediator(MainMenuMediator);
			mediatorMap.mapMatcher(new TypeMatcher().allOf(BaseView, SideMenuView)).toMediator(SideMenuMediator);

			commandMap.map(ApplicationEvent.INIT).toCommand(SetupCommand);
			
			eventDispatcher.dispatchEvent(new ApplicationEvent(ApplicationEvent.INIT));
		}
	}
}
